#module Menu donde estara la gema menus que gestionara  uan lista de menus
module Menu
class Menu
    
    include Comparable
    attr_reader :titulo , :porcentaje, :platos, :vct, :proteinas, :grasas, :hidratos  
    def initialize (titulo, porcentaje, platos, vct, proteinas, grasas, hidratos)
        @titulo = titulo
        @porcentaje = porcentaje
        @platos = Array.new
        platos.each{|x| @platos.push(Plato.new(x))}
        @vct = vct
        @proteinas = proteinas
        @grasas = grasas
        @hidratos = hidratos
        
    end
    
    #Métdodo auxiliar que le pasas un string por parametro y nos lo transformaen float.
    def cogefloat(dato)
       number =dato.gsub(/[a-z]/,"")
       number =number.gsub("%",".")
       number =number.gsub(",",".")
       number =number.to_f
       return number
    end
    
   
    def <=>(anOther)
        return nil if anOther == nil
        x=[ cogefloat(vct)]
        y=[ cogefloat(anOther.vct)]
        x <=> y
    end
    
    def ==(anOther)
        return nil if anOther == nil
        x=[ cogefloat(vct), cogefloat(proteinas), cogefloat(grasas), cogefloat(hidratos) ]
        y=[ cogefloat(anOther.vct), cogefloat(anOther.proteinas), cogefloat(anOther.grasas), cogefloat(anOther.hidratos) ]
        x==y
    end
    
    
    def to_s
        porcentaje = corregir_porcentaje
        @titulo + " (#{porcentaje}%)\n" + getConjuntoPlatos + "V.C.T. | % " + getVct + " | " + getProteinas + " - " + getGrasas + " - " + getHidrados + "\n"
    end
    
    def corregir_porcentaje
        t = ""
        @porcentaje.each{|x| t = t + " - " + x.to_s}
        final = t[3,t.length]
        final
    end
    
    def getPlato(index)
        @platos[index].to_s
    end

    def getTitulo
        @titulo
    end
    
    def getIngesta
        @porcentaje 
    end
    
    def getVct
        @vct 
    end
    
    def getProteinas
        @proteinas 
    end
    
    def getGrasas
        @grasas 
    end
    
    def getHidrados
        @hidratos 
    end
    
    def getDescripcion (x)
        @platos[x].descripcion
    end
    
    def getConjuntoPlatos
        t = ""
        @platos.each{|x| t = t + x.to_s + "\n"}
        t
    end
end


end