require "menu"

    
class MenuDE        
    include Comparable
    attr_reader :titulo , :porcentaje, :platos, :vct, :proteinas, :grasas, :hidratos, :grupo, :edades  

    def initialize(&bloque)
        @titulo
        @porcentaje
        @platos = []
        @vct
        @proteinas
        @grasas
        @hidratos
        @grupo
        @edades
        
        if block_given?  
            if bloque.arity == 1
                yield self
            else
                instance_eval(&bloque) 
            end
        end
    end
    
    def plato (options = {})
        plato = []
        plato << "#{options[:descripcion]}" if options[:descripcion]
        plato << "#{options[:porcion]}" if options[:porcion]
        plato << "#{options[:gramos]}" if options[:gramos]
        @platos.push(Plato.new(plato))
    end
    
    def titulo (name, options = {})
        @titulo = name
        @grupo = "#{options[:grupo]}" if options[:grupo]
        @edades = "#{options[:edad]}" if options[:edad]
    end
     
    def ingesta (options = {})
        porcentaje = []
        porcentaje << "#{options[:min]}" if options[:min]
        porcentaje << "#{options[:max]}" if options[:max]
        @porcentaje = porcentaje
    end
    
    def porcentajes (options = {})
        @vct = "#{options[:vct]}" if options[:vct]
        @proteinas = "#{options[:proteinas]}" if options[:proteinas]
        @grasas = "#{options[:grasas]}" if options[:grasas]
        @hidratos = "#{options[:hidratos]}" if options[:hidratos]
    end
    
    
    
    #Métdodo auxiliar que le pasas un string por parametro y nos lo transformaen float.
    def cogefloat(dato)
       number =dato.gsub(/[a-z]/,"")
       number =number.gsub("%",".")
       number =number.gsub(",",".")
       number =number.to_f
       return number
    end
    
   
    def <=>(anOther)
        return nil if anOther == nil
        x=[ cogefloat(vct)]
        y=[ cogefloat(anOther.vct)]
        x <=> y
    end
    
    def ==(anOther)
        return nil if anOther == nil
        x=[ cogefloat(vct), cogefloat(proteinas), cogefloat(grasas), cogefloat(hidratos) ]
        y=[ cogefloat(anOther.vct), cogefloat(anOther.proteinas), cogefloat(anOther.grasas), cogefloat(anOther.hidratos) ]
        x==y
    end
    

    def to_s
        porcentaje = corregir_porcentaje
        @titulo + " (#{porcentaje}%)\n" + getConjuntoPlatos + "V.C.T. | % " + getVct + " kcal | " + getProteinas + "% - " + getGrasas + "% - " + 
        getHidrados + "%\n Grupo de alimentos: " + grupo.to_s + "\n Grupo de edad: " + edades.to_s + "\n"
    end
    
    def corregir_porcentaje
        t = ""
        @porcentaje.each{|x| t = t + " - " + x.to_s}
        final = t[3,t.length]
        final
    end
    
    def getPlato(index)
        @platos[index].to_s
    end

    def getTitulo
        @titulo
    end
    
    def getIngesta
        @porcentaje 
    end
    
    def getVct
        @vct 
    end
    
    def getProteinas
        @proteinas 
    end
    
    def getGrasas
        @grasas 
    end
    
    def getHidrados
        @hidratos 
    end
    
    def getDescripcion (x)
        @platos[x].descripcion
    end
    
    def getConjuntoPlatos
        t = ""
        @platos.each{|x| t = t + x.to_s + "\n"}
        t
    end
end
   
   
   
   
   
   
   
   
   
